method maxsum(x: int, y: int) returns(sum: int, max: int)
  ensures sum == x + y
  ensures max >= x && max >= y
  ensures max == x || max == y
{
    sum := x + y;    
    if x > y {
        max := x;
    }
    else {
        max := y;
    }
}

method maxsumReverse(sum: int, max: int) returns (x: int, y: int)
  requires sum <= 2*max
  ensures sum == x + y
  ensures max >= x && max >= y
  ensures max == x || max == y
{
    x := max;
    y := sum - x;
}

method TestMaxSum(x: int, y: int)
{
  var s, m := maxsum(x, y);
  var xx, yy := maxsumReverse(s, m);
  assert (x == xx && y == yy) || (x == yy && y == xx);
}

