function Average(x: int, y: int) : int
{
    (x + y) / 2
}

method Triple(x: int) returns (r: int)
  ensures r == 3*x
{
    var y := 2 * x;
    r := x + y;
    assert r == 3 * x;
}

method Triple'(x: int) returns (r: int)
  ensures r == 3*x
{
  if {
      case x < 18 =>
        var a,b := 2*x, 4*x;
        r:= (a + b) / 2 ;
      case 0 <= x =>
        var y := 2 * x;
        r := x + y ;
  }
  assert r == 3 * x;
}

method Triple''(x: int) returns (r: int)
  ensures Average(r, 3 * x) == 3 * x
{
    r := 3 * x + 1;
}

////////////////

method Triple'''(x: int) returns (r: int)
  ensures Average(r, 3 * x) == 3 * x
  ensures Average(r - 1, 3 * x) < 3 * x
{
    r := 3 * x;
}
